Index: /code/trunk/data/gui/schemes/WindowsMenuWidgets.scheme
===================================================================
--- /code/trunk/data/gui/schemes/WindowsMenuWidgets.scheme	(revision 6746)
+++ /code/trunk/data/gui/schemes/WindowsMenuWidgets.scheme	(revision 6746)
@@ -0,0 +1,42 @@
+<?xml version="1.0" ?>
+<GUIScheme Name="WindowsMenuWidgets">
+    <WindowAlias Alias="MenuWidgets/StaticImage"              Target="WindowsLook/StaticImage" />
+    <WindowAlias Alias="MenuWidgets/StaticText"               Target="WindowsLook/StaticText" />
+    <WindowAlias Alias="MenuWidgets/TabButtonPane"            Target="WindowsLook/TabButtonPane" />
+    <WindowAlias Alias="MenuWidgets/TabContentPane"           Target="WindowsLook/TabContentPane" />
+    <WindowAlias Alias="MenuWidgets/Checkbox"                 Target="WindowsLook/Checkbox" />
+    <WindowAlias Alias="MenuWidgets/Combobox"                 Target="WindowsLook/Combobox" />
+    <WindowAlias Alias="MenuWidgets/ComboDropList"            Target="WindowsLook/ComboDropList" />
+    <WindowAlias Alias="MenuWidgets/ComboEditbox"             Target="WindowsLook/ComboEditbox" />
+    <WindowAlias Alias="MenuWidgets/Editbox"                  Target="WindowsLook/Editbox" />
+    <WindowAlias Alias="MenuWidgets/FrameWindow"              Target="WindowsLook/FrameWindow" />
+    <WindowAlias Alias="MenuWidgets/GroupBox"                 Target="WindowsLook/GroupBox" />
+    <WindowAlias Alias="MenuWidgets/ItemListbox"              Target="WindowsLook/ItemListbox" />
+    <WindowAlias Alias="MenuWidgets/ListboxItem"              Target="WindowsLook/ListboxItem" />
+    <WindowAlias Alias="MenuWidgets/Listbox"                  Target="WindowsLook/Listbox" />
+    <WindowAlias Alias="MenuWidgets/ListHeader"               Target="WindowsLook/ListHeader" />
+    <WindowAlias Alias="MenuWidgets/ListHeaderSegment"        Target="WindowsLook/ListHeaderSegment" />
+    <WindowAlias Alias="MenuWidgets/MultiLineEditbox"         Target="WindowsLook/MultiLineEditbox" />
+    <WindowAlias Alias="MenuWidgets/Menubar"                  Target="WindowsLook/Menubar" />
+    <WindowAlias Alias="MenuWidgets/MenuItem"                 Target="WindowsLook/MenuItem" />
+    <WindowAlias Alias="MenuWidgets/MultiColumnList"          Target="WindowsLook/MultiColumnList" />
+    <WindowAlias Alias="MenuWidgets/PopupMenu"                Target="WindowsLook/PopupMenu" />
+    <WindowAlias Alias="MenuWidgets/ProgressBar"              Target="WindowsLook/ProgressBar" />
+    <WindowAlias Alias="MenuWidgets/Button"                   Target="WindowsLook/Button" />
+    <WindowAlias Alias="MenuWidgets/ImageButton"              Target="WindowsLook/ImageButton" />
+    <WindowAlias Alias="MenuWidgets/RadioButton"              Target="WindowsLook/RadioButton" />
+    <WindowAlias Alias="MenuWidgets/SystemButton"             Target="WindowsLook/SystemButton" />
+    <WindowAlias Alias="MenuWidgets/ScrollablePane"           Target="WindowsLook/ScrollablePane" />
+    <WindowAlias Alias="MenuWidgets/HorizontalScrollbar"      Target="WindowsLook/HorizontalScrollbar" />
+    <WindowAlias Alias="MenuWidgets/VerticalScrollbar"        Target="WindowsLook/VerticalScrollbar" />
+    <WindowAlias Alias="MenuWidgets/Slider"                   Target="WindowsLook/Slider" />
+    <WindowAlias Alias="MenuWidgets/Spinner"                  Target="WindowsLook/Spinner" />
+    <WindowAlias Alias="MenuWidgets/TabButton"                Target="WindowsLook/TabButton" />
+    <WindowAlias Alias="MenuWidgets/TabControl"               Target="WindowsLook/TabControl" />
+    <WindowAlias Alias="MenuWidgets/HorizontalScrollbarThumb" Target="WindowsLook/HorizontalScrollbarThumb" />
+    <WindowAlias Alias="MenuWidgets/SliderThumb"              Target="WindowsLook/SliderThumb" />
+    <WindowAlias Alias="MenuWidgets/VerticalScrollbarThumb"   Target="WindowsLook/VerticalScrollbarThumb" />
+    <WindowAlias Alias="MenuWidgets/Titlebar"                 Target="WindowsLook/Titlebar" />
+    <WindowAlias Alias="MenuWidgets/Tooltip"                  Target="WindowsLook/Tooltip" />
+    <WindowAlias Alias="MenuWidgets/Tree"                     Target="WindowsLook/Tree" />
+</GUIScheme>
Index: /code/trunk/data/gui/scripts/AudioMenu.lua
===================================================================
--- /code/trunk/data/gui/scripts/AudioMenu.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/AudioMenu.lua	(revision 6746)
@@ -1,16 +1,7 @@
 -- AudioMenu.lua
 
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    AudioMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
+local P = createMenuSheet("AudioMenu")
 
-P.filename = "AudioMenu"
-P.layoutString = "AudioMenu.layout"
-
-function P:init()
+function P.onLoad()
     soundMgr = orxonox.SoundManager:getInstance()
     block = false
@@ -43,5 +34,5 @@
     for k,v in pairs(themeList) do
         item = CEGUI.createListboxTextItem(v)
-        item:setSelectionBrushImage("TaharezLook", "MultiListSelectionBrush")
+        item:setSelectionBrushImage(menuImageSet, "MultiListSelectionBrush")
         CEGUI.toListbox(listboxwindow):addItem(item)
     end
@@ -178,5 +169,5 @@
 
 function P.AudioBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideMenuSheet(P.name)
 end
 
Index: /code/trunk/data/gui/scripts/ControlsMenu.lua
===================================================================
--- /code/trunk/data/gui/scripts/ControlsMenu.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/ControlsMenu.lua	(revision 6746)
@@ -1,25 +1,16 @@
 -- ControlsMenu.lua
 
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    ControlsMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "ControlsMenu"
-P.layoutString = "ControlsMenu.layout"
+local P = createMenuSheet("ControlsMenu")
 
 function P.ControlsMouseControlsButton_clicked(e)
-    showGUI("MouseControlsMenu", true)
+    showMenuSheet("MouseControlsMenu", true)
 end
 
 function P.ControlsKeyboardControlsButton_clicked(e)
-    showGUI("KeyBindMenu", true)
+    showMenuSheet("KeyBindMenu", true)
 end
 
 function P.ControlsBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideMenuSheet(P.name)
 end
 
Index: /code/trunk/data/gui/scripts/CreditsMenu.lua
===================================================================
--- /code/trunk/data/gui/scripts/CreditsMenu.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/CreditsMenu.lua	(revision 6746)
@@ -1,17 +1,8 @@
 -- CreditsMenu.lua
 
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    CreditsMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "CreditsMenu"
-P.layoutString = "CreditsMenu.layout"
+local P = createMenuSheet("CreditsMenu")
 
 function P.CreditsBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideMenuSheet(P.name)
 end
 
Index: /code/trunk/data/gui/scripts/DecisionPopup.lua
===================================================================
--- /code/trunk/data/gui/scripts/DecisionPopup.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/DecisionPopup.lua	(revision 6746)
@@ -1,17 +1,5 @@
 -- DecisionPopup.lua
 
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    DecisionPopup = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "DecisionPopup"
-P.layoutString = "DecisionPopup.layout"
-
-function P:init()
-end
+local P = createMenuSheet("DecisionPopup")
 
 function P.setCallback(functionPtr)
@@ -28,5 +16,5 @@
         P.functionPtr(true)
     end
-    hideGUI("DecisionPopup")
+    hideMenuSheet("DecisionPopup")
 end
 
@@ -35,5 +23,5 @@
         P.functionPtr(false)
     end
-    hideGUI("DecisionPopup")
+    hideMenuSheet("DecisionPopup")
 end
 
Index: /code/trunk/data/gui/scripts/GUISheet.lua
===================================================================
--- /code/trunk/data/gui/scripts/GUISheet.lua	(revision 6746)
+++ /code/trunk/data/gui/scripts/GUISheet.lua	(revision 6746)
@@ -0,0 +1,43 @@
+-- GUISheet.lua
+
+local P = {}
+_G[_REQUIREDNAME or "GUISheet"] = P
+P.__index = P
+
+-- Don't use directly --> use HUDSheet.new or MenuSheet.new
+function P.new(_name)
+    local newSheet = { name = _name }
+    setmetatable(newSheet, P)
+    return newSheet
+end
+
+-- Override this function if you need to do work on load
+function P:onLoad()
+end
+
+-- hide function for the GUI
+function P:hide()
+    self.window:hide()
+    self.bVisible = false
+end
+
+-- show function for the GUI
+function P:show()
+    self.window:show()
+    self.bVisible = true
+end
+
+function P:load()
+    -- Load the layout that describes the sheet
+    self.window = winMgr:loadWindowLayout(self.name .. ".layout")
+    if self.window == nil then
+        error("Could not load layout file for GUI sheet '"..self.name.."'")
+    end
+    -- Hide it at first
+    self:hide()
+    -- Allow sheets to do some work upon loading
+    self:onLoad()
+    return self
+end
+
+return P
Index: /code/trunk/data/gui/scripts/GUITools.lua
===================================================================
--- /code/trunk/data/gui/scripts/GUITools.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/GUITools.lua	(revision 6746)
@@ -1,4 +1,19 @@
+-- Returns a new menu sheet
+-- See MenuSheet.new for details about the parameters
+function createMenuSheet(name, bHidePrevious, tShowCursor, tUseKeyboard, bBlockJoyStick)
+    local sheet = require("MenuSheet").new(name, bHidePrevious, tShowCursor, tUseKeyboard, bBlockJoyStick)
+    _G[sheet.name] = sheet -- Global access required because of the event handlers
+    return sheet
+end
+
+-- Returns a new HUD sheet
+function createHUDSheet(name)
+    local sheet = require("HUDSheet").new(name)
+    _G[sheet.name] = sheet -- Global access required because of the event handlers
+    return sheet
+end
+
 function openDecisionPopup( text, callbackPtr )
-    showGUI("DecisionPopup", false, true)
+    showMenuSheet("DecisionPopup", false, true)
     DecisionPopup.setCallback(callbackPtr)
     DecisionPopup.setText(text)
@@ -6,5 +21,5 @@
 
 function openInfoPopup(text, functionPtr, closeButton, arguments)
-    showGUI("InfoPopup", false, true)
+    showMenuSheet("InfoPopup", false, true)
     InfoPopup.execute(functionPtr, arguments)
     InfoPopup.setText(text)
Index: /code/trunk/data/gui/scripts/GameplayMenu.lua
===================================================================
--- /code/trunk/data/gui/scripts/GameplayMenu.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/GameplayMenu.lua	(revision 6746)
@@ -1,16 +1,7 @@
 -- GameplayMenu.lua
 
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    GameplayMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
+local P = createMenuSheet("GameplayMenu")
 
-P.filename = "GameplayMenu"
-P.layoutString = "GameplayMenu.layout"
-
-function P:init()
+function P.onLoad()
     dropdown = winMgr:getWindow("orxonox/ThemeCombobox")
     local themeList = {}
@@ -20,5 +11,5 @@
     for k,v in pairs(themeList) do
         item = CEGUI.createListboxTextItem(v)
-        item:setSelectionBrushImage("TaharezLook", "MultiListSelectionBrush")
+        item:setSelectionBrushImage(menuImageSet, "MultiListSelectionBrush")
         CEGUI.toCombobox(dropdown):addItem(item)
     end
@@ -27,24 +18,24 @@
 function P.GameplayThemeCombobox_changed(e)
     -- theme
-    debug("event: theme")
+    logMessage(0, "event: theme")
 end
 
 function P.GameplayDifficultyEasyButton_clicked(e)
     -- difficulty easy
-    debug("event: easy")
+    logMessage(0, "event: easy")
 end
 
 function P.GameplayDifficultyNormalButton_clicked(e)
     -- difficulty normal
-    debug("event: normal")
+    logMessage(0, "event: normal")
 end
 
 function P.GameplayDifficultyHardButton_clicked(e)
     -- difficulty hard
-    debug("event: hard")
+    logMessage(0, "event: hard")
 end
 
 function P.GameplayBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideMenuSheet(P.name)
 end
 
Index: /code/trunk/data/gui/scripts/GraphicsMenu.lua
===================================================================
--- /code/trunk/data/gui/scripts/GraphicsMenu.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/GraphicsMenu.lua	(revision 6746)
@@ -1,16 +1,7 @@
 -- GraphicsMenu.lua
 
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    GraphicsMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
+local P = createMenuSheet("GraphicsMenu")
 
-P.filename = "GraphicsMenu"
-P.layoutString = "GraphicsMenu.layout"
-
-function P:init()
+function P.onLoad()
     block = true
     file = orxonox.PathConfig:getConfigPathString() .. orxonox.getConfig("GraphicsManager", "ogreConfigFile_")
@@ -62,5 +53,5 @@
     for k,v in pairs(resolutionList) do
         item = CEGUI.createListboxTextItem(v)
-        item:setSelectionBrushImage("TaharezLook", "MultiListSelectionBrush")
+        item:setSelectionBrushImage(menuImageSet, "MultiListSelectionBrush")
         CEGUI.toListbox(listboxwindow):addItem(item)
     end
@@ -152,5 +143,5 @@
     if scrollbar_active == false then
         -- brightness
-        debug("event: brightness")
+        logMessage(0, "event: brightness")
     end
 end
@@ -162,5 +153,5 @@
 function P.GraphicsBrightnessScrollbar_ended(e)
     -- brightness
-    debug("event: brightness")
+    logMessage(0, "event: brightness")
     scrollbar_active = false
 end
@@ -201,5 +192,5 @@
 
 function P.GraphicsBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideMenuSheet(P.name)
 end
 
Index: /code/trunk/data/gui/scripts/HUDSheet.lua
===================================================================
--- /code/trunk/data/gui/scripts/HUDSheet.lua	(revision 6746)
+++ /code/trunk/data/gui/scripts/HUDSheet.lua	(revision 6746)
@@ -0,0 +1,15 @@
+-- HUDSheet.lua
+
+local P = {} -- Local alias, always use it in this file
+HUDSheet = P -- Global name
+setmetatable(P, require("GUISheet")) -- Inherit from GUISheet
+P.__index = P -- Provide class character
+
+-- Use this function to construct a new HUDSheet
+function P.new(name)
+    local newSheet = GUISheet.new(name)
+    setmetatable(newSheet, P)
+    return newSheet
+end
+
+return P
Index: /code/trunk/data/gui/scripts/InGameMenu.lua
===================================================================
--- /code/trunk/data/gui/scripts/InGameMenu.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/InGameMenu.lua	(revision 6746)
@@ -1,18 +1,5 @@
 -- InGameMenu.lua
 
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    InGameMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "InGameMenu"
-P.layoutString = "InGameMenu.layout"
-
-function P:init()
-end
-
+local P = createMenuSheet("InGameMenu")
 
 -- events for ingamemenu
@@ -25,18 +12,18 @@
     orxonox.Game:getInstance():popState()
     orxonox.Game:getInstance():requestState("mainmenu")
-    hideGUI("InGameMenu")
+    hideMenuSheet("InGameMenu")
 end
 
 function P.button_settings_clicked(e)
-    showGUI("SettingsMenu", true)
+    showMenuSheet("SettingsMenu", true)
 end
 
 function P.button_return_clicked(e)
-    hideGUI("InGameMenu")
+    hideMenuSheet("InGameMenu")
 end
 
 function P.callback(doExit)
     if doExit then
-        hideGUI("InGameMenu")
+        hideMenuSheet("InGameMenu")
         orxonox.execute("exit")
     end
Index: /code/trunk/data/gui/scripts/InfoPopup.lua
===================================================================
--- /code/trunk/data/gui/scripts/InfoPopup.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/InfoPopup.lua	(revision 6746)
@@ -1,18 +1,5 @@
 -- InfoPopup.lua
 
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-
-if _REQUIREDNAME == nil then
-    InfoPopup = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "InfoPopup"
-P.layoutString = "InfoPopup.layout"
-
-function P:init()
-end
+local P = createMenuSheet("InfoPopup")
 
 function P.execute(functionPtr, arguments)
@@ -26,5 +13,5 @@
 end
 
-function P.setText( text )
+function P.setText(text)
     winMgr:getWindow("orxonox/InfoPopup_text"):setText( text )
 end
@@ -42,5 +29,5 @@
 -- events for ingamemenu
 function P.close(e)
-    hideGUI("InfoPopup")
+    hideMenuSheet(P.name)
 end
 
Index: /code/trunk/data/gui/scripts/InitialiseGUI.lua
===================================================================
--- /code/trunk/data/gui/scripts/InitialiseGUI.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/InitialiseGUI.lua	(revision 6746)
@@ -1,228 +1,31 @@
-local schemeMgr = CEGUI.SchemeManager:getSingleton()
-winMgr = CEGUI.WindowManager:getSingleton()
-local logger = CEGUI.Logger:getSingleton()
-local system = CEGUI.System:getSingleton()
-local cursor = CEGUI.MouseCursor:getSingleton()
+-- Define some global shortcuts for common Managers
+guiMgr    = orxonox.GUIManager:getInstance()
+inputMgr  = orxonox.InputManager:getInstance()
+schemeMgr = CEGUI.SchemeManager:getSingleton()
+winMgr    = CEGUI.WindowManager:getSingleton()
 
-schemeMgr:loadScheme("TaharezLookSkin.scheme")
--- load scheme with our own images
+-- Load all required skins
+schemeMgr:loadScheme("TaharezGreenLook.scheme")
+--schemeMgr:loadScheme("TaharezLook.scheme")
+--schemeMgr:loadScheme("WindowsLook.scheme")
+--schemeMgr:loadScheme("VanillaLook.scheme")
+--schemeMgr:loadScheme("SleekSpaceLook.scheme")
+
+-- Connect skin specific window types with our own window types
+-- By loading a different file (if there is) you can change the skin
+-- of the menus or the HUD independently
+schemeMgr:loadScheme("TaharezGreenMenuWidgets.scheme")
+menuImageSet = "TaharezGreenLook"
+schemeMgr:loadScheme("TaharezGreenHUDWidgets.scheme")
+hudImageSet = "TaharezGreenLook"
+
+-- Just a remaining test hack
 schemeMgr:loadScheme("OrxonoxGUIScheme.scheme")
 
-system:setDefaultMouseCursor("TaharezLook", "MouseArrow")
+local system = CEGUI.System:getSingleton()
+system:setDefaultMouseCursor(menuImageSet, "MouseArrow")
 system:setDefaultFont("BlueHighway-12")
-system:setDefaultTooltip("TaharezLook/Tooltip")
+system:setDefaultTooltip("MenuWidgets/Tooltip")
 
-loadedGUIs = {}
-cursorVisibility = {}
-activeSheets = {}
-nrOfActiveSheets = 0
-root = nil
-bShowsCursor = false
-bHidePrevious = {}
-
--- Require all tools
+-- Convenience function and additional tools
 require("GUITools")
-
--- loads the GUI with the specified filename
--- be sure to set the global variable "filename" before calling this function
-function loadGUI(filename)
-    -- check if it already exists
-    loadedGui = loadedGUIs[filename]
-    if loadedGui == nil then
-        loadedGuiNS = require(filename)
-        if loadedGuiNS == nil then
-            return
-        end
-        loadedGui = loadedGuiNS:load()
-        loadedGUIs[filename] = loadedGui
-        -- if there has no GUI been loaded yet, set new GUI as current
-        if table.getn(loadedGUIs) == 1 then
-            current = loadedGUIs[1]
-        end
-        -- hide new GUI as we do not want to show it accidentially
-        loadedGui:hide()
-    end
-    return loadedGui
-end
-
-function showGUI(filename, hidePrevious, bCursorVisible, ptr)
-    gui = showGUI(filename, hidePrevious, bCursorVisible)
-    gui.overlay = ptr
-end
-
--- shows the specified and loads it if not loaded already
--- be sure to set the global variable "filename" before calling this function
-function showGUI(filename, hidePrevious, bCursorVisible)
-    if bCursorVisible == nil then
-        if nrOfActiveSheets > 0 then
-            bCursorVisible = cursorVisibility[activeSheets[nrOfActiveSheets]]
-        else
-            bCursorVisible = true
-        end
-    end
-
-    if root == nil then
-        setBackground("")
-    end
-
-    local currentGUI = loadedGUIs[filename]
-    if(currentGUI == nil) then
-        currentGUI = loadGUI(filename)
-    end
-
-    if(root:isChild(currentGUI.window)) then
-        root:removeChildWindow(currentGUI.window)
-    end
-    root:addChildWindow(currentGUI.window)
-
-    if bCursorVisible then
-        showCursor()
-    else
-        hideCursor()
-    end
-
-    if find( activeSheets, filename ) ~= nil then
-        table.remove( activeSheets, find( activeSheets, filename ) )
-        nrOfActiveSheets = nrOfActiveSheets - 1
-    else
-        if nrOfActiveSheets == 0 then
-            orxonox.InputManager:getInstance():enterState("guiMouseOnly")
-            orxonox.HumanController:pauseControl()
-        end
-    end
-    nrOfActiveSheets = nrOfActiveSheets + 1
-    table.insert(activeSheets, filename)
-    activeSheets[nrOfActiveSheets] = filename
-    bHidePrevious[filename]=hidePrevious
-    cursorVisibility[filename] = bCursorVisible
-
-    if hidePrevious == true then
-        for i=1,nrOfActiveSheets-1 do
-            loadedGUIs[ activeSheets[i] ]:hide()
-        end
-    end
-    currentGUI:show()
-    return currentGUI
-end
-
-function hideCursor()
-    if bShowsCursor==true then
-        bShowsCursor=false
-        cursor:hide()
-    end
-end
-
-function showCursor()
-    if bShowsCursor==false then
-        bShowsCursor=true
-        cursor:show()
-    end
-end
-
-function hideGUI(filename)
-    local currentGUI = loadedGUIs[filename]
-    if currentGUI == nil then
-        return
-    end
-    currentGUI:hide()
-    if bHidePrevious[filename] == true then
-        local i = nrOfActiveSheets-1
-        while i>0 do
-            loadedGUIs[ activeSheets[i] ]:show()
-            if bHidePrevious[filename]==true then
-                break
-            else
-                i=i-1
-            end
-        end
-    end
-    root:removeChildWindow(currentGUI.window)
-    local i=1
-    while activeSheets[i] do
-        if activeSheets[i+1] == nil then
-            if activeSheets[i-1] ~= nil then
-                if cursorVisibility[ activeSheets[i-1] ] == true then
-                    showCursor()
-                else
-                    hideCursor()
-                end
-            else
-                hideCursor()
-            end
-        end
-        if activeSheets[i] == filename then
-            table.remove( activeSheets, i )
-            nrOfActiveSheets = nrOfActiveSheets-1
-        else
-            i = i+1
-        end
-    end
-    cursorVisibility[filename] = nil -- remove the cursor visibility of the current gui from the table
-    bHidePrevious[filename] = nil
-    if nrOfActiveSheets == 0 then
-        orxonox.InputManager:getInstance():leaveState("guiMouseOnly")
-        orxonox.HumanController:resumeControl()
-        hideCursor()
-    end
-end
-
-function hideAllGUIs()
-    while nrOfActiveSheets ~= 0 do
-        hideGUI(activeSheets[nrOfActiveSheets])
-    end
-end
-
-function keyESC()
-    if nrOfActiveSheets == 1 and activeSheets[1] == "MainMenu" then
-        orxonox.execute("exit")
-    elseif nrOfActiveSheets > 0 then
-        orxonox.execute("hideGUI "..activeSheets[nrOfActiveSheets])
-    else
-        showGUI("InGameMenu")
-    end
-end
-
-function setBackground(filename)
-    local newroot
-    if root ~= nil then
-        root:rename("oldRootWindow")
-    end
-    if filename ~= "" then
-        newroot = winMgr:loadWindowLayout(filename .. ".layout")
-        newroot:rename("AbsoluteRootWindow")
-        system:setGUISheet(newroot)
-    else
-        newroot = winMgr:createWindow("DefaultWindow", "AbsoluteRootWindow")
-        newroot:setProperty("Alpha", "0.0")
-        newroot:setSize(CEGUI.UVector2(CEGUI.UDim(1.0,0),CEGUI.UDim(1.0,0)))
-        system:setGUISheet(newroot)
-    end
-    if root ~= nil then
-        local child
-        while root:getChildCount()~=0 do
-            child = root:getChildAtIdx(0)
-            root:removeChildWindow(child)
-            newroot:addChildWindow(child)
-        end
-        winMgr:destroyWindow(root)
-    end
-    newroot:show()
-    root = newroot
-end
-
-function find(table, value)
-    local i=0
-    while table[i] ~= nil do
-        if table[i]==value then
-            return i
-        else
-            i=i+1
-        end
-    end
-    return nil
-end
-
---TODO: Needed?
-function test(e)
-    debug(0, "Blubb")
-end
Index: /code/trunk/data/gui/scripts/KeyBindMenu.lua
===================================================================
--- /code/trunk/data/gui/scripts/KeyBindMenu.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/KeyBindMenu.lua	(revision 6746)
@@ -1,17 +1,7 @@
 -- KeyBindMenu.lua
 
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-
-if _REQUIREDNAME == nil then
-    KeyBindMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "KeyBindMenu"
-P.layoutString = "KeyBindMenu.layout"
-
-function P:init()
+local P = createMenuSheet("KeyBindMenu")
+
+function P.onLoad()
 
     commandList = {}
@@ -68,5 +58,5 @@
 
     --Calculate design parameters:
-    sampleWindow = winMgr:createWindow("TaharezLook/StaticText", "orxonox/KeyBindPane/SampleWindow")
+    sampleWindow = winMgr:createWindow("MenuWidgets/StaticText", "orxonox/KeyBindPane/SampleWindow")
     sampleWindow:setText("SampleText")
 
@@ -125,5 +115,5 @@
     line:setPosition(CEGUI.UVector2(CEGUI.UDim(0, 0), CEGUI.UDim(0, lineHeight*(k-1))))
 
-    local command = winMgr:createWindow("TaharezLook/StaticText", "orxonox/KeyBindPane/Binding" .. k .. "/Command")
+    local command = winMgr:createWindow("MenuWidgets/StaticText", "orxonox/KeyBindPane/Binding" .. k .. "/Command")
     command:setText(nameList[k])
     command:setSize(CEGUI.UVector2(CEGUI.UDim(0, commandWidth), CEGUI.UDim(1, 0)))
@@ -132,9 +122,9 @@
     offset = offset + commandWidth + spaceWidth
 
-    local plus = winMgr:createWindow("TaharezLook/TabButton", "orxonox/KeyBindPane/Binding" .. k .. "/Plus")
+    local plus = winMgr:createWindow("MenuWidgets/TabButton", "orxonox/KeyBindPane/Binding" .. k .. "/Plus")
     plus:setSize(CEGUI.UVector2(CEGUI.UDim(0, addWidth), CEGUI.UDim(0.7, 0)))
     plus:setPosition(CEGUI.UVector2(CEGUI.UDim(0, offset), CEGUI.UDim(0.15, 0)))
     plus:setText("add")
-    orxonox.GUIManager:subscribeEventHelper(plus, "Clicked", P.filename .. ".KeyBindPlus_clicked")
+    orxonox.GUIManager:subscribeEventHelper(plus, "Clicked", P.name .. ".KeyBindPlus_clicked")
     line:addChildWindow(plus)
     offset = offset + addWidth + spaceWidth
@@ -142,5 +132,5 @@
     local numButtons = orxonox.KeyBinderManager:getInstance():getCurrent():getNumberOfBindings(commandList[k]);
     for i=0,(numButtons-1) do
-        local button = winMgr:createWindow("TaharezLook/TabButton", "orxonox/KeyBindPane/Binding" .. k .. "/Button" .. i)
+        local button = winMgr:createWindow("MenuWidgets/TabButton", "orxonox/KeyBindPane/Binding" .. k .. "/Button" .. i)
         local name = orxonox.KeyBinderManager:getInstance():getCurrent():getBinding(commandList[k],i)
         name = P.KeyNameNiceifier(name)
@@ -151,14 +141,14 @@
         button:setSize(CEGUI.UVector2(CEGUI.UDim(0, buttonWidth), CEGUI.UDim(0.7, 0)))
         button:setPosition(CEGUI.UVector2(CEGUI.UDim(0, offset), CEGUI.UDim(0.15, 0)))
-        orxonox.GUIManager:subscribeEventHelper(button, "Clicked", P.filename .. ".KeyBindButton_clicked")
-        --button:subscribeScriptedEvent("EventClicked", P.filename .. ".KeyBindButton_clicked")
+        orxonox.GUIManager:subscribeEventHelper(button, "Clicked", P.name .. ".KeyBindButton_clicked")
+        --button:subscribeScriptedEvent("EventClicked", P.name .. ".KeyBindButton_clicked")
         line:addChildWindow(button)
         offset = offset + buttonWidth
 
-        local clear = winMgr:createWindow("TaharezLook/TabButton", "orxonox/KeyBindPane/Binding" .. k .. "/Clear" .. i)
+        local clear = winMgr:createWindow("MenuWidgets/TabButton", "orxonox/KeyBindPane/Binding" .. k .. "/Clear" .. i)
         clear:setSize(CEGUI.UVector2(CEGUI.UDim(0, clearWidth), CEGUI.UDim(0.7, 0)))
         clear:setPosition(CEGUI.UVector2(CEGUI.UDim(0, offset), CEGUI.UDim(0.15, 0)))
         clear:setText("X")
-        orxonox.GUIManager:subscribeEventHelper(clear, "Clicked", P.filename .. ".KeyBindClear_clicked")
+        orxonox.GUIManager:subscribeEventHelper(clear, "Clicked", P.name .. ".KeyBindClear_clicked")
         line:addChildWindow(clear)
         offset = offset + clearWidth + spaceWidth
@@ -254,5 +244,5 @@
 
 function P.KeyBindBackButton_clicked(e)
-    hideGUI("KeyBindMenu")
+    hideMenuSheet("KeyBindMenu")
 end
 
Index: /code/trunk/data/gui/scripts/MainMenu.lua
===================================================================
--- /code/trunk/data/gui/scripts/MainMenu.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/MainMenu.lua	(revision 6746)
@@ -1,14 +1,5 @@
 -- MainMenu.lua
 
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    MainMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "MainMenu"
-P.layoutString = "MainMenu.layout"
+local P = createMenuSheet("MainMenu")
 
 -- events for MainMenu
@@ -18,17 +9,17 @@
 
 function P.SingleplayerButton_clicked(e)
-    showGUI("SingleplayerMenu", true)
+    showMenuSheet("SingleplayerMenu", true)
 end
 
 function P.MultiplayerButton_clicked(e)
-    showGUI("MultiplayerMenu", true)
+    showMenuSheet("MultiplayerMenu", true)
 end
 
 function P.SettingsButton_clicked(e)
-    showGUI("SettingsMenu", true)
+    showMenuSheet("SettingsMenu", true)
 end
 
 function P.CreditsButton_clicked(e)
-    showGUI("CreditsMenu", true)
+    showMenuSheet("CreditsMenu", true)
 end
 
Index: /code/trunk/data/gui/scripts/MenuSheet.lua
===================================================================
--- /code/trunk/data/gui/scripts/MenuSheet.lua	(revision 6746)
+++ /code/trunk/data/gui/scripts/MenuSheet.lua	(revision 6746)
@@ -0,0 +1,36 @@
+-- MenuSheet.lua
+-- Base class for all GUI sheets that represent a menu.
+-- Inherits itself from GUISheet
+
+local P = {}  -- Local alias, always use it in this file
+MenuSheet = P -- Global name
+setmetatable(P, require("GUISheet")) -- Inherit from GUISheet
+P.__index = P -- Provide class character
+
+-- Use this function to construct a new MenuSheet.
+-- Parameters:
+-- Except for _name, you can provide nil. Then the default value will be used.
+-- For _tShowCusor and _tUseKeyboard you can specify TriBool.Dontcare if the value doesn't matter at all. Then the value of the underlaying sheet will be used.
+function P.new(_name, _bHidePrevious, _tShowCursor, _tUseKeyboard, _bBlockJoyStick)
+    local newSheet = GUISheet.new(_name)
+    newSheet.bHidePrevious  = handleDefArg(_bHidePrevious,  true)
+    newSheet.tShowCursor    = handleDefArg(_tShowCusor,     TriBool.True)
+    newSheet.tUseKeyboard   = handleDefArg(_tUseKeyboard,   TriBool.Dontcare)
+    newSheet.bBlockJoyStick = handleDefArg(_bBlockJoyStick, false)
+
+    setmetatable(newSheet, P)
+    return newSheet
+end
+
+function P:load()
+    -- Create the input state
+    self.inputState = guiMgr:createInputState("GUI_" .. self.name,
+        self.tShowCursor, self.tUseKeyboard, self.bBlockJoyStick)
+
+    -- load() of base 'class'
+    GUISheet.load(self)
+
+    return self
+end
+
+return P
